/***
*
*	File derived from bspfile.h and cmdlib.h
*	File created by Jeroen "ShadowLord" Bogers (resgen@hltools.com)
*
*	Orriginal file copyrights:
*
*	Copyright (c) 1998, Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
****/

// General includes
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>

// ===============================================================================
// bspfile.h

#define BSPVERSION 30

typedef struct
{
	int		fileofs, filelen;
} lump_t;

#define ENT_HEADER_LUMPS 1

typedef struct
{
	int			version;	
	lump_t		lumps[ENT_HEADER_LUMPS]; // We only need the entity lump
} eheader_t;

extern int entdatasize;
extern char *dentdata;


typedef unsigned char byte;

// Function prototypes

int filelength (FILE *f);
int LoadEntHeader (FILE *f, eheader_t *header);
int LoadBSPEntityInfo (char *filename);
void UnLoadBSPEntityInfo();

// cmdlib
FILE *SafeOpenRead (char *filename);
int SafeRead (FILE *f, void *buffer, int count);
int    LoadFile (char *filename, void **bufferptr);