// ResGen header file
#ifdef _WIN32
#include "StdAfx.h"
#endif

#include "bspent.h" // Home-made bsp entity reader dirived from Valve source.
#include "vstring.h"
#include "varray.h"

// #include <iostream.h> // File IO support
#ifdef _WIN32
#include <conio.h> // Console IO - only used for getch()
#endif

// #include <stdio.h> // File IO
// #include <io.h> // File IO
#include <fcntl.h> // IO parameters
#include <string.h> // String functions
#include <stdlib.h> // Standard lib

#ifdef _WIN32
#include <windows.h> // Windows app include file - used for the status bar.
#include <direct.h> // windows directory changing functions
#endif

#include <time.h> // Time functions
#include "globalf.h" // global functions

#ifndef _WIN32
#include <sys/types.h> // Include for types - Linux
#include <dirent.h> // Inlcude for directoryies - Linux
#include <sys/stat.h> // Include for stat functions - Linux
#include <unistd.h> // Include for support of stat fucntions - Linux
#endif


// Constants
#ifdef _WIN32
const char *version = "1.12"; // Set the Win32 version
#else
const char *version = "1.12_l"; // Set the linux version
const int STAT_MAX = 4; // STAT_MAX can be tweaked... 4 seems OK for a 8kbyte/sec connection
#endif

const int la = 'a'; // asc value of a
const int lz = 'z'; // asc value of z
const int UA = 'A'; // asc value of A
const int UZ = 'Z'; // asc value of Z
const int zero = '0';  // asc value of 0
const int nine = '9';  // asc value of 9


// Global vars
#ifdef _WIN32
static HANDLE houtput; // Console output handle

char sbar1[81]; // Status bar 1
char sbar2[81]; // Status bar 2
#endif

typedef enum helptype // Define an enum for the helptype
{
	no_help,
	files_help,
	dirs_help
};

bool verbal = true; // Set verbal on
bool statusline = true; // Status line on
bool lowercase = true; // Lowercase mode on
bool overwrite = false; // overwite off
bool update = false; // update off
bool addition = false; // addition off
#ifndef _WIN32
bool linktrace = true; // trace links
bool displaydir = true; // display current search dir
#endif
#ifdef _WIN32
bool winconsole = true; // We are in windows
#endif

char *additionstring; // Char array for the additionstring.

int updyear; // Year to update
int updmonth; // Month to update
int updday; // Day to update from

#ifndef _WIN32
int statcount; // Stat counter (to make screen updates appear less)
int totalbsp; // Total BSP files
int currentbsp ; // Current bsp file
#endif


// Function prototypes

#ifdef _WIN32
void WriteStatusText( char *text, WORD linecolor, int pos);
void upstatus();
void progressbar(char *output, int total, int done, int length);
#endif

bool filecheck(VArray *array, VString *file);
bool legalchar(char *string, int pos);
void addfile(VString *string, FILE *file, VArray *verify_array, char *prefix, char *suffix);

int MakeRes(char *bspfilename);

void givecredits();

void givehelp(helptype help, bool verbaloverride);

#ifdef _WIN32
void listdir(VArray *filelist, VString *startdir, bool subdir, bool firstdir);
#endif

int main(int argc, char* argv[]);

void makedate(VString *date, int *day, int *month, int *year);
void getdate(VString *strdate);

#ifdef _WIN32
void getexitkey();
void getcontkey();
#endif

bool fgetline(FILE *txtfile, VString *line);

void MemError();